/***************************************************************************
 *            Image.cc
 *
 *  Sun Apr 11 20:01:04 2004
 *  Copyright  2004  Deva
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include "Image.h"

#define SEP '/'

Image::Image(wxString& file) {
	path = new wxString(file);
	name = new wxString(path->AfterLast(SEP));
	date = new wxString("42/42-2042");
	
	fprintf(stderr, "[Image]Loading: %s\n", path->GetData());
	image = NULL;
	thumbnail = getThumbnail(*path);
}

Image::~Image() {}


wxBitmap *Image::getThumbnail(wxString path) {
	wxString file = path.AfterLast(SEP);
	wxString dir = path.BeforeLast(SEP);
	wxString thumbnailfile = dir + SEP + ".thumbnails" + SEP + file + ".png";
	
	fprintf(stderr, "Processing: ");
	fprintf(stderr, file);
	fprintf(stderr, " in dir ");
	fprintf(stderr, dir);
	fprintf(stderr, "\n");
	
	wxBitmap *bmp;
	wxImage *img = new wxImage();
	
	fprintf(stderr, thumbnailfile);

	FILE *fp;
	if(!(fp = fopen(thumbnailfile, "r"))) {
		fprintf(stderr, " - Not Found, creating...\n");
		img->LoadFile(path, wxBITMAP_TYPE_ANY, -1);
		(img->Scale(32, 32)).SaveFile(thumbnailfile, wxBITMAP_TYPE_PNG);
	} else { fclose(fp); }
	
	fprintf(stderr, " - Found, loading...\n");
	img->LoadFile(thumbnailfile, wxBITMAP_TYPE_ANY, -1);
	bmp = new wxBitmap(img, -1);
	
	return bmp;
}
	
void Image::addComment(wxString *comment) {}
void Image::addNote(wxString *note, wxPoint *point) {}

wxBitmap *Image::getThumbnail() {
	return thumbnail;
}

wxImage *Image::getImage() { 
	if(!image) {
		image = new wxImage();
		image->LoadFile(path->GetData(), wxBITMAP_TYPE_ANY, -1);
	}
	return image; 
}

wxString *Image::getName() { return name; }
wxString *Image::getDate() { return date; }

Comment::Comment() {}
Comment::~Comment() {}
void Comment::remove() {}
