/***************************************************************************
 *            Image.h
 *
 *  Sun Apr 11 20:01:31 2004
 *  Copyright  2004  Deva
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef __IMAGE_H__
#define __IMAGE_H__

#include <wx/image.h>
#include <wx/bitmap.h>
#include <wx/dir.h>


class Comment {
public:
	Comment();
	~Comment();
	void remove();

private:
	Comment *prev;
	Comment *next;
};


class Image {
public:
	Image(wxString &file);
	~Image();
	void addComment(wxString *comment);
	void addNote(wxString *note, wxPoint *point);
	wxBitmap *getThumbnail();
	wxImage *getImage();
	wxString *getName();
	wxString *getDate();

private:
	wxBitmap *getThumbnail(wxString path);

	wxString *path;
	wxString *name;
	wxString *date;
	Comment *comments;
	wxImage *image;
	wxBitmap *thumbnail;
};

#endif
