// ----------------------------------------------------------------------------
// ImageMatrix
// ----------------------------------------------------------------------------
#include "ImageMatrix.h"

BEGIN_EVENT_TABLE(ImageMatrix, wxScrolledWindow)
	EVT_SIZE(ImageMatrix::OnSize)
END_EVENT_TABLE()

ImageMatrix::ImageMatrix(wxWindow* parent)
        : wxScrolledWindow(parent, -1, wxDefaultPosition, wxDefaultSize,
                           wxNO_FULL_REPAINT_ON_RESIZE)
{
	imglst = new wxImageList();
	images = new wxList();
}

ImageMatrix::~ImageMatrix() {}

void ImageMatrix::Update(wxList *list) {
	free(images);
	images = list;
	fprintf(stderr, "Images to show: %d\n", list->GetCount());
	/*
	//Write the names of the images to show on the console
	wxNode *node = list->GetFirst();
	while (node) {
		img = (Image*)node->GetData();
		fprintf(stderr, "[ImageMatrix::Update]: %s\n", img->getName()->GetData());
		node = node->GetNext();
	}
	*/
}

void ImageMatrix::OnSize(wxSizeEvent& event) {
	int w, h;
	wxBitmap *bmp;
	Image *img;
	
	GetClientSize(&w, &h);
	if(w < 0 || h < 0) return;
	fprintf(stderr, "[ImageMatrix::OnSize] %dx%d\n", w, h);

	free(imglst);
	imglst = new wxImageList(w / options.cols,
							 h / options.rows);
	wxNode *node = images->GetLast();
	for(int cnt = 0; cnt < (options.cols * options.rows); cnt ++) {
		if(node) {
			img = (Image*)node->GetData();
			wxImage image = (img->getImage())->Scale(w / options.cols, h / options.rows);
			bmp = new wxBitmap(image);
			node = node->GetPrevious();
			fprintf(stderr, "[ImageMatrix::OnSize] Added %s\n", img->getName()->GetData());
		} else {
			bmp = new wxBitmap();
			fprintf(stderr, "[ImageMatrix::OnSize] Added dummy\n");
		}
		imglst->Add(*bmp);
		
	}
	fprintf(stderr, "[ImageMatrix::OnSize] Done\n");
}



void ImageMatrix::OnDraw(wxDC& dc) {
//	Draw(int index, wxDC& dc, int x, int x, int flags = wxIMAGELIST_DRAW_NORMAL, const bool solidBackground = false)
	int w, h;
	imglst->GetSize(0, w, h);
	for(int x = 0; x < options.cols; x++) {
		for(int y = 0; y < options.rows; y++) {
			imglst->Draw((options.cols * y) + x, dc, x * w, y * h);
		}
	}
	
	
/*
	wxMirrorDC dc(dcOrig, m_mirror);
	
	dc.SetPen(*wxBLACK_PEN);
	dc.DrawLine(0, 0, 100, 200);
	
	dc.SetBackgroundMode(wxTRANSPARENT);
	dc.DrawText(_T("ImageMatrix"), 50, 50);
	
	dc.SetPen(*wxRED_PEN);
	dc.SetBrush(*wxGREEN_BRUSH);
	dc.DrawRectangle(120, 120, 100, 80);
*/
	//dc->Blit()
	/*
	Blit(
		wxCoord xdest,
		wxCoord ydest,
		wxCoord width,
		wxCoord height,
		wxDC* source,
		wxCoord xsrc,
		wxCoord ysrc,
		int logicalFunc = wxCOPY,
		bool useMask = false,
		wxCoord xsrcMask = -1,
		wxCoord ysrcMask = -1)
	*/
	
	dc.DrawText("Fisk", 50, 50);
}
