//-------------------------------------------------------------------------
// MainWindow
//-------------------------------------------------------------------------

#include "MainWindow.h"



BEGIN_EVENT_TABLE(MainWindow, wxFrame)
    EVT_MENU(SHOW_SELECTION, MainWindow::ShowSelection)

    EVT_MENU(QUIT, MainWindow::Quit)
	
	EVT_SET_FOCUS(MainWindow::GotFocus)
END_EVENT_TABLE()

// My frame constructor
MainWindow::MainWindow()
			: wxFrame(NULL, -1, _T("wxSplitterWindow sample"),
					wxPoint(options.mainwindow.x, options.mainwindow.y), 
					wxSize(options.mainwindow.w, options.mainwindow.h),
					wxDEFAULT_FRAME_STYLE | wxNO_FULL_REPAINT_ON_RESIZE) {
	
	CreateStatusBar(2);
	
	// Make a menubar
	wxMenu *splitMenu = new wxMenu;
	splitMenu->Append(SHOW_SELECTION, "&Show selection\tCtrl-S", "Show selection");

	splitMenu->AppendSeparator();
	
	splitMenu->Append(QUIT, _T("E&xit\tAlt-X"), _T("Exit"));
	
	wxMenuBar *menuBar = new wxMenuBar;
	menuBar->Append(splitMenu, "&Filer");

	SetMenuBar(menuBar);
	
	m_splitter = new MainWindowSplitter(this);
	
	imagematrix = new ImageMatrix(m_splitter);
	fileselector = new FileSelector(m_splitter, imagematrix);
		
	m_splitter->SplitVertically(fileselector, imagematrix, options.sash.pos);

	SetStatusText("Velkommen til PC-Show", 1);
}

MainWindow::~MainWindow() {}

void MainWindow::GotFocus(wxFocusEvent& event) {
	//GetAllFiles("/home/deva/images", files, wxEmptyString, wxDIR_FILES);
	fprintf(stderr, "Got Focus\n");
}

void MainWindow::Quit(wxCommandEvent& WXUNUSED(event) ) {
    Close(TRUE);
}

void MainWindow::ShowSelection(wxCommandEvent& WXUNUSED(event)) {
	wxList *list;
	long i;
	
	SetStatusText("Showing images.");
	
	list = new wxList();
	i = fileselector->GetFirstSelected();
	while(i != -1) {
		Image *img = (Image*)fileselector->GetItemData(i);
		fprintf(stderr, "[ShowSelection] %s", img->getName()->GetData());
		
		list->Append((wxObject*)img);
		i = fileselector->GetNextSelected(i);
	}
	
	SetStatusText("Showing images..");
	
	imagematrix->Update(list);
	
	SetStatusText("Showing images...done!");
}
