#ifndef __MAINWINDOW_H__
#define __MAINWINDOW_H__

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/log.h"

    #include "wx/app.h"
    #include "wx/frame.h"

    #include "wx/scrolwin.h"
    #include "wx/menu.h"

    #include "wx/textdlg.h"       // for wxGetTextFromUser
#endif

#include "wx/splitter.h"
#include "wx/dcmirror.h"

#include "MainWindowSplitter.h"
#include "FileSelector.h"
#include "ImageMatrix.h"
#include "Options.h"
#include "Image.h"
// ID for the menu commands
enum
{
    QUIT,
	SHOW_SELECTION,
};

class MainWindow: public wxFrame
{
public:
    MainWindow();
    virtual ~MainWindow();

    // Menu commands
    void ShowSelection(wxCommandEvent& event);

    void Quit(wxCommandEvent& event);

	void GotFocus(wxFocusEvent& event);

private:
    FileSelector *fileselector;
    ImageMatrix *imagematrix;

    wxSplitterWindow* m_splitter;

    DECLARE_EVENT_TABLE()
    DECLARE_NO_COPY_CLASS(MainWindow)
};

#endif
