// ----------------------------------------------------------------------------
// MainWindowSplitter
// ----------------------------------------------------------------------------
#include "MainWindowSplitter.h"

BEGIN_EVENT_TABLE(MainWindowSplitter, wxSplitterWindow)
	EVT_SPLITTER_SASH_POS_CHANGED(-1, MainWindowSplitter::OnPositionChanged)
	EVT_SPLITTER_SASH_POS_CHANGING(-1, MainWindowSplitter::OnPositionChanging)
	
	EVT_SPLITTER_DCLICK(-1, MainWindowSplitter::OnDClick)
	
	EVT_SPLITTER_UNSPLIT(-1, MainWindowSplitter::OnUnsplit)
END_EVENT_TABLE()

MainWindowSplitter::MainWindowSplitter(wxFrame *parent)
					: wxSplitterWindow(parent, -1,
						wxDefaultPosition, wxDefaultSize,
						wxSP_3D | wxSP_LIVE_UPDATE |
						wxCLIP_CHILDREN) {
	m_frame = parent;
}

void MainWindowSplitter::OnPositionChanged(wxSplitterEvent& event) {
// 	wxLogStatus(m_frame, _T("Position has changed, now = %d (or %d)"),
// 		event.GetSashPosition(), GetSashPosition());

//	SetSashPosition(options.sash.pos);
	
// 	event.Skip();
}

void MainWindowSplitter::OnPositionChanging(wxSplitterEvent& event) {
/*	wxLogStatus(m_frame, _T("Position is changing, now = %d (or %d)"),
		event.GetSashPosition(), GetSashPosition());
	
//	SetSashPosition(options.sash.pos);
		
	event.StopPropagation();*/
}

void MainWindowSplitter::OnDClick(wxSplitterEvent& event) {
	m_frame->SetStatusText(_T("Splitter double clicked"), 1);

	event.Skip();
}

void MainWindowSplitter::OnUnsplit(wxSplitterEvent& event) {
	m_frame->SetStatusText(_T("Splitter unsplit"), 1);
	
	event.Skip();
}
